package strangepatterns2.binder;

import java.beans.*;
import java.util.*;
import java.lang.reflect.InvocationTargetException;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class Binder
    implements ActionListener {
//
  public static final int FIRST_TO_SECOND = 1;
//
  public static final int SECOND_TO_FIRST = 2;
//
  private Object first, second;
//
  private int direction;
//
  private String[] fProps, sProps;
//
  private Converter [] convs;



  public Binder() {
  }

  public void setFirst(Object bean) {
    first = bean;
  }

  public void setSecond(Object bean) {
    second = bean;
  }

  public void setDirection(int direction) {
    this.direction = direction;
  }

  public void bind(String[] firstProps, String[] secondProps,Converter [] converters) {
    fProps = firstProps;
    sProps = secondProps;
    convs = converters;
  }

  public void execute() throws IntrospectionException {
    BeanInfo fInfo = Introspector.getBeanInfo(first.getClass());
    BeanInfo sInfo = Introspector.getBeanInfo(second.getClass());
    PropertyDescriptor[] fDesc = findProperties(fInfo, fProps);
    //System.out.println("-------------------------------------------");
    PropertyDescriptor[] sDesc = findProperties(sInfo, sProps);
    for (int i = 0; i < fDesc.length; i++) {
      invoke(fDesc[i], sDesc[i],convs[i]);
    }
  }

  public void actionPerformed(ActionEvent actionEvent) {
    try {
      execute();
    }
    catch (IntrospectionException ex) {
      ex.printStackTrace();
    }
  }

  private PropertyDescriptor[] findProperties(BeanInfo info, String[] props) {
    ArrayList result = new ArrayList();
    Set toFind = new HashSet(Arrays.asList(props));
    PropertyDescriptor[] allDesc = info.getPropertyDescriptors();
    for (int i = 0; i < allDesc.length; i++) {
      //System.out.println("name: " + allDesc[i].getName());
      if (toFind.contains(allDesc[i].getName())) {
        result.add(allDesc[i]);
      }
    }
    return (PropertyDescriptor[]) result.toArray(new PropertyDescriptor[result.
                                                 size()]);
  }

  private void invoke(PropertyDescriptor firstDesc, PropertyDescriptor secondDesc, Converter conv) {
    try {
      if (direction == FIRST_TO_SECOND) {
        //System.out.println("first: "+first.getName()+" second: "+second.getName());
        Object msg = firstDesc.getReadMethod().invoke(first, null);
        msg = conv.fromFirstToSecond(msg);
        secondDesc.getWriteMethod().invoke(second, new Object[] {msg});
      }
      if (direction == SECOND_TO_FIRST) {
        Object msg = secondDesc.getReadMethod().invoke(second, null);
        msg = conv.fromSecondToFirst(msg);
        firstDesc.getWriteMethod().invoke(first, new Object[] {msg});
      }
    }
    catch (InvocationTargetException exc) {
      exc.printStackTrace();
      throw new RuntimeException(String.valueOf(exc.getTargetException()));
    }
    catch (Exception exc) {
      exc.printStackTrace();
      throw new RuntimeException(String.valueOf(exc));
    }
  }

} //END