package strangepatterns2.binder;

import javax.swing.*;
import java.awt.Dimension;
import java.awt.Container;
import java.io.File;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class Launcher
    extends JFrame {

  public Launcher() {
    setTitle("Courier Pattern");
  }

  public void start() {
    SpringLayout layout = new SpringLayout();
    JButton browse = new JButton();
    JTextField field = new JTextField();
    JLabel label = new JLabel("choosen: ");

    setupButton(browse, field);
    setupField(field);

    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setBounds(50, 50, 350, 60);
    getContentPane().setLayout(layout);
    setupConstraints(layout, browse, field, label);

    getContentPane().add(browse);
    getContentPane().add(label);
    getContentPane().add(field);
    setVisible(true);
  }

  private void setupButton(JButton button, JTextField field) {
    JFileChooser chooser = new JFileChooser();
    ButtonAction action = new ButtonAction(chooser);
    button.setAction(action);
    button.setPreferredSize(new Dimension(80, 20));


    Converter converter = new Converter(){
      public Object fromFirstToSecond(Object data) {
        File target = (File)data;
        if(target != null){
          return target.getAbsolutePath();
        }
       return "";
      }

      public Object fromSecondToFirst(Object data) {
        return new File(String.valueOf(data));
      }
    };


    Binder binder = new Binder();
    chooser.addActionListener(binder);
    binder.setFirst(chooser);
    binder.setSecond(field);
    binder.setDirection(Binder.FIRST_TO_SECOND);
    binder.bind(new String[] {"selectedFile"}
                , new String[] {"text"}, new Converter[]{converter});

  }

  private void setupField(JTextField field) {
    field.setPreferredSize(new Dimension(140, 20));
  }

  private void setupConstraints(SpringLayout layout, JButton button,
                                JTextField field, JLabel label) {
    Container c = getContentPane();
    layout.putConstraint(SpringLayout.WEST, button, 5, SpringLayout.WEST, c);
    layout.putConstraint(SpringLayout.NORTH, button, 5, SpringLayout.NORTH, c);
    layout.putConstraint(SpringLayout.WEST, label, 90, SpringLayout.WEST,
                         button);
    layout.putConstraint(SpringLayout.NORTH, label, 5, SpringLayout.NORTH, c);
    layout.putConstraint(SpringLayout.WEST, field, 70, SpringLayout.WEST, label);
    layout.putConstraint(SpringLayout.NORTH, field, 5, SpringLayout.NORTH, c);
  }

  public static void main(String[] args) {
    Launcher l = new Launcher();
    l.start();
  }

} //END