package strangepatterns2.courier;

import javax.swing.*;
import java.awt.GridLayout;
import java.awt.Dimension;
import javax.swing.SpringLayout;
import java.awt.Container;

import strangepatterns2.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class Launcher
    extends JFrame {

  public Launcher() {
    setTitle("Courier Pattern");
  }

  public void start() {
    SpringLayout layout = new SpringLayout();
    JButton browse = new JButton();
    Field field = new Field();
    JLabel label = new JLabel("choosen: ");

    setupButton(browse, field);
    setupField(field);

    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setBounds(50, 50, 350, 60);
    getContentPane().setLayout(layout);
    setupConstraints(layout, browse, field, label);

    getContentPane().add(browse);
    getContentPane().add(label);
    getContentPane().add(field);
    setVisible(true);
  }

  private void setupButton(JButton button, Field field) {
    Chooser chooser = new Chooser();
    Courier courier = new Courier(chooser, field);
    button.setAction(courier);
    button.setPreferredSize(new Dimension(80, 20));
  }

  private void setupField(Field field) {
    field.setPreferredSize(new Dimension(140, 20));
  }

  private void setupConstraints(SpringLayout layout, JButton button,
                                Field field, JLabel label) {
    Container c = getContentPane();
    layout.putConstraint(SpringLayout.WEST, button, 5, SpringLayout.WEST, c);
    layout.putConstraint(SpringLayout.NORTH, button, 5, SpringLayout.NORTH, c);
    layout.putConstraint(SpringLayout.WEST, label, 90, SpringLayout.WEST,
                         button);
    layout.putConstraint(SpringLayout.NORTH, label, 5, SpringLayout.NORTH, c);
    layout.putConstraint(SpringLayout.WEST, field, 70, SpringLayout.WEST, label);
    layout.putConstraint(SpringLayout.NORTH, field, 5, SpringLayout.NORTH, c);
  }

  public static void main(String[] args) {
    Launcher l = new Launcher();
    l.start();
  }

} //END