package strangepatterns2.objectadaptation;

import java.util.HashMap;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class Launcher {

  public Launcher() {
  }

  public void useWriterIfNotNull(Writer w,Object o){
   if(w==null) {
    System.out.println("No Adapter Present...");
    return;
   }
   w.write(o);
  }

  public void useReaderIfNotNull(Reader r){
   if(r==null) {
    System.out.println("No Adapter Present...");
    return;
   }
   r.read();
  }

  public void registerAdpter() {
    AdapterRegistry.getInstance().registerAdapter(Table.class, Reader.class,
                                                  TableReaderAdapter.class);
    AdapterRegistry.getInstance().registerAdapter(Table.class, Writer.class,
                                                  TableWriterAdapter.class);
    AdapterRegistry.getInstance().registerAdapter(Shape.class, Reader.class,
                                                  ShapeReaderAdapter.class);
    AdapterRegistry.getInstance().registerAdapter(Shape.class, Writer.class,
                                                  ShapeWriterAdapter.class);
  }

  public void start() {
    Table t = new Table("Employee");
    Circle c = new Circle();
    WriteableCircle c2 = new WriteableCircle();

    //-------- TABLE ------------
    Writer w = (Writer) t.adapt(Writer.class);
    useWriterIfNotNull(w,t);

    Reader r = (Reader) t.adapt(Reader.class);
    useReaderIfNotNull(r);

    //------- CIRCLE ----------
    w = (Writer) c.adapt(Writer.class);
    useWriterIfNotNull(w,c);

    r = (Reader) c.adapt(Reader.class);
    useReaderIfNotNull(r);


    // ------ WRITABLE CIRCLE -------
    w = (Writer) c2.adapt(Writer.class);
    useWriterIfNotNull(w,c2);

    r = (Reader) c2.adapt(Reader.class);
    useReaderIfNotNull(r);
  }

  public static void main(String[] args) {
    Launcher l = new Launcher();
    l.registerAdpter();
    l.start();
  }

}